mscorlib [00 00 00 00 00 00 00 00 04 00 00 00 00 00 00 00] 1.0.5000.0 2.0.0.0 4.0.0.0 Gtk# is thread aware, but not thread safe; See the <link location="node:gtk-sharp/programming/threads">Gtk# Thread Programming</link> for details. System.Object System.Runtime.InteropServices.ComVisible(true)

Starting with the net_v40_long, the common language runtime (CLR) is moving away from providing security policy for computers. We recommend that you use Windows Software Restriction Policies (SRP) or AppLocker as a replacement for CLR security policy. The information in this topic applies to the .NET Framework version 3.5 and earlier; it does not apply to the net_v40_short and later. For more information about this and other changes, see Security Changes in the .NET Framework Version 4.0.

The highest level of security policy is enterprise-wide. Successive lower levels of hierarchy represent further policy restrictions, but can never grant more permissions than allowed by higher levels. The following policy levels are implemented:

Enterprise: Security policy for all managed code in an enterprise.

Machine: Security policy for all managed code run on the computer.

User: Security policy for all managed code run by the user.

Application domain: Security policy for all managed code in an application.

A policy level consists of a set of code groups organized into a single rooted tree (see ), a set of named permission sets that are referenced by the code groups to specify permissions to be granted to code belonging to the code group, and a list of fully-trusted assemblies.

Use to enumerate the policy levels.

Represents the security policy levels for the common language runtime. This class cannot be inherited.

- Method
  1.0.5000.0
  2.0.0.0
  4.0.0.0
  System.Obsolete("All GACed assemblies are now fully trusted and all permissions now succeed on fully trusted code.")
  System.Void ``

  The method is not supported in version 2.0 or later of the .NET Framework because the list of full trust assemblies is not used in those versions.

  Adds a corresponding to the specified to the list of objects used to determine whether an assembly is a member of the group of assemblies that should not be evaluated.

  The used to create the to add to the list of objects used to determine whether an assembly is a member of the group of assemblies that should not be evaluated.
- Method
  1.0.5000.0
  2.0.0.0
  4.0.0.0
  System.Obsolete("All GACed assemblies are now fully trusted and all permissions now succeed on fully trusted code.")
  System.Void ``

  The method is not supported in version 2.0 or later of the .NET Framework because the list of full trust assemblies is not used in those versions.

  Adds the specified to the list of objects used to determine whether an assembly is a member of the group of assemblies that should not be evaluated.

  The to add to the list of objects used to determine whether an assembly is a member of the group of assemblies that should not be evaluated.
- Method
  1.0.5000.0
  2.0.0.0
  4.0.0.0
  System.Void ``

  Named permission sets are scoped by policy level.

  Adds a to the current policy level.

  The to add to the current policy level.
- Method
  1.0.5000.0
  2.0.0.0
  4.0.0.0
  System.Security.NamedPermissionSet `` `` To be added

  Replaces a in the current policy level with the specified .

  A copy of the that was replaced.

  The name of the to replace. The that replaces the specified by the parameter.
- Method
  1.0.5000.0
  2.0.0.0
  4.0.0.0
  System.Security.Policy.PolicyLevel

  This method creates a new with the "AppDomain". The new will initially contain the same objects as in the default computer policy, and will have a single root code group that grants FullTrust to all code.

  Creates a new policy level for use at the application domain policy level.

  The newly created .

- Method
  1.0.5000.0
  2.0.0.0
  4.0.0.0
  System.Void `` To be added

  Reconstructs a security object with a given state from an XML encoding.

  The XML encoding to use to reconstruct the security object.
- Property
  1.0.5000.0
  2.0.0.0
  4.0.0.0
  System.Obsolete("All GACed assemblies are now fully trusted and all permissions now succeed on fully trusted code.")
  System.Collections.IList To be added: an object of type 'Collections.IList'

  are granted full trust during security policy evaluation of assemblies not in the list, but are not automatically granted full trust when directly evaluated by the security policy system.

  The property is not supported in version 2.0 or later of the .NET Framework because the list of full trust assemblies is not used in those versions.

  Gets a list of objects used to determine whether an assembly is a member of the group of assemblies used to evaluate security policy.

- Method
  1.0.5000.0
  2.0.0.0
  4.0.0.0
  System.Security.NamedPermissionSet `` To be added

  Returns the in the current policy level with the specified name.

  The in the current policy level with the specified name, if found; otherwise, null.

  The name of the to find.
- Property
  1.0.5000.0
  2.0.0.0
  4.0.0.0
  System.String To be added: an object of type 'string'

  The label is used to help the administrator identify the policy level.

  Gets a descriptive label for the policy level.

- Property
  1.0.5000.0
  2.0.0.0
  4.0.0.0
  System.Collections.IList To be added: an object of type 'Collections.IList' To be added

  Gets a list of named permission sets defined for the policy level.

- Method
  1.0.5000.0
  2.0.0.0
  4.0.0.0
  System.Void

  This method does not make modifications to the current . Instead, it updates the object's file and the that the security system uses to evaluate policy.

  This method is used by the caspol -recover option (see [<topic://cpgrfcodeaccesssecuritypolicyutilitycaspolexe>]).

  Replaces the configuration file for this with the last backup (reflecting the state of policy prior to the last time it was saved) and returns it to the state of the last save.

- Method
  1.0.5000.0
  2.0.0.0
  4.0.0.0
  System.Obsolete("All GACed assemblies are now fully trusted and all permissions now succeed on fully trusted code.")
  System.Void ``

  The method is not supported in version 2.0 or later of the .NET Framework because the list of full trust assemblies is not used in those versions.

  Removes an assembly with the specified from the list of assemblies the policy level uses to evaluate policy.

  The of the assembly to remove from the list of assemblies used to evaluate policy.
- Method
  1.0.5000.0
  2.0.0.0
  4.0.0.0
  System.Obsolete("All GACed assemblies are now fully trusted and all permissions now succeed on fully trusted code.")
  System.Void ``

  The method is not supported in version 2.0 or later of the .NET Framework because the list of full trust assemblies is not used in those versions.

  Removes an assembly with the specified from the list of assemblies the policy level uses to evaluate policy.

  The of the assembly to remove from the list of assemblies used to evaluate policy.
- Method
  1.0.5000.0
  2.0.0.0
  4.0.0.0
  System.Security.NamedPermissionSet `` To be added

  Removes the specified from the current policy level.

  The that was removed.

  The to remove from the current policy level.
- Method
  1.0.5000.0
  2.0.0.0
  4.0.0.0
  System.Security.NamedPermissionSet `` To be added

  Removes the with the specified name from the current policy level.

  The that was removed.

  The name of the to remove.
- Method
  1.0.5000.0
  2.0.0.0
  4.0.0.0
  System.Void

  The default state is different for each policy level.

  Returns the current policy level to the default state.

- Method
  1.0.5000.0
  2.0.0.0
  4.0.0.0
  System.Security.Policy.PolicyStatement ``

  is the basic policy evaluation operation for policy levels. Given a set of evidence as input, this method tests membership conditions of code groups starting at the root and working down as matched. The combination of permissions resulting from the matching code groups produces a that is returned.

  In granting permissions to code, security policy uses the resolved policy statements for all applicable policy levels, together with the code request for permissions.

  Resolves policy based on evidence for the policy level, and returns the resulting .

  The resulting .

  The used to resolve the .
- Method
  1.0.5000.0
  2.0.0.0
  4.0.0.0
  System.Security.Policy.CodeGroup ``

  You can use this method to analyze the effect of the code groups in a policy level with respect to a certain set of evidence. For example, if the security policy is not granting an assembly the minimum code request permissions it needs, it can be difficult to tell by examination of the code groups exactly where the problem is.

  Since this method returns a code group that can have child code groups, it is possible for an administrator to examine the code group and its child code groups and determine which code groups match.

  Resolves policy at the policy level and returns the root of a code group tree that matches the evidence.

  A representing the root of a tree of code groups matching the specified evidence.

  The used to resolve policy.
- Property
  1.0.5000.0
  2.0.0.0
  4.0.0.0
  System.Security.Policy.CodeGroup To be added.

  Every policy level has one root .

  Gets or sets the root code group for the policy level.

- Property
  1.0.5000.0
  2.0.0.0
  4.0.0.0
  System.String To be added: an object of type 'string' To be added

  Gets the path where the policy file is stored.

- Method
  1.0.5000.0
  2.0.0.0
  4.0.0.0
  System.Security.SecurityElement To be added

  Creates an XML encoding of the security object and its current state.

  An XML encoding of the security object, including any state information.

- Property
  2.0.0.0
  4.0.0.0
  System.Runtime.InteropServices.ComVisible(false)
  System.Security.PolicyLevelType To be added.

  The highest level of security policy is enterprise-wide. Successive lower levels of hierarchy represent further policy restrictions, but can never grant more permissions than allowed by higher levels. The policy levels in order are the following.

  Enterprise

  Machine

  User

  Application domain

  For more information, see .

  Gets the type of the policy level.